<?php
/*
Plugin Name: WP2Qzone 
Plugin URI: http://fairyfish.net/project/wp-qzone/
Description: 同步 WordPress 博客日志到 Qzone。
Version: 1.0
Author: Denis
Author URI: http://wpjam.com/
*/
function smtp_mailer_qqmail($subject,$body){
	$qq_number = get_option('qq_number');
	$qq_password = get_option('qq_password');

	if(!$qq_number || ! $qq_password) return;

	if ( !class_exists('PHPMailer') ) {
		require_once ABSPATH . WPINC . '/class-phpmailer.php';
		require_once ABSPATH . WPINC . '/class-smtp.php';
	}
	$mail = new PHPMailer();

	$mail->IsSMTP();
	$mail->Mailer   = "smtp";
	$mail->CharSet  = 'utf-8';
	$mail->Encoding = 'base64';
	$mail->IsHTML(true);
	$mail->SMTPAuth = true;
	$mail->Host     = "smtp.qq.com";
	$mail->Username = $qq_number."@qq.com";
	$mail->Password = $qq_password;
	$mail->From     = $qq_number."@qq.com";
	$mail->FromName = $qq_number;  

	$mail->AddAddress($qq_number."@qzone.qq.com");
	$mail->Subject = $subject;
	$mail->Body    = $body;
	$mail->Send();
}
add_action('publish_post', 'publish_post_2_qzone', 0);
function publish_post_2_qzone($post_ID){
	$qzone_full_text = get_option('qzone_full_text');

	$qzone = get_post_meta($post_ID, 'qzone', true);

	if($qzone) return;
	
	$qzone_post=get_post($post_ID);

	$post_title = trim($qzone_post->post_title);

	if($qzone_full_text){
		$post_content= wpautop($qzone_post->post_content).'<br />查看全文：<a href="'.get_permalink($post_ID).'">'.get_permalink($post_ID).'</a>';

	}else{
		$post_except = trim($qzone_post->post_except);
		if($post_except){
			$post_content = $post_except;
		}else{
			$post_content = mb_substr(strip_tags(trim($qzone_post->post_content)),0,220);
		}

		$post_content= $post_content.'<br />原文：<a href="'.get_permalink($post_ID).'">'.get_permalink($post_ID).'</a>';
	}

	//echo $post_content; //exit;
		
	smtp_mailer_qqmail($post_title,$post_content);

	add_post_meta($post_ID, 'qzone', 'true', true);
}

add_action('admin_menu', 'wp2qzone_add_page');
function wp2qzone_add_page() {
	add_options_page('WP2Qzone同步选项', 'WP2Qzone', 'manage_options', 'wp2qzone', 'wp2qzone_do_page');
}

function wp2qzone_do_page() {
	if($_POST['submit']){
		$qq_number = $_POST['qq_number'];
		$qq_password = $_POST['qq_password'];
		$qzone_full_text = $_POST['qzone_full_text'];

		update_option('qq_number',$qq_number);
		update_option('qq_password',$qq_password);
		update_option('qzone_full_text',$qzone_full_text);
	}else{
		$qq_number = get_option('qq_number');
		$qq_password = get_option('qq_password');
		$qzone_full_text = get_option('qzone_full_text');
	}
?>
	<div class="wrap">
		<h2>WP2Qzone同步选项</h2>
		<form method="post" action="#">
			<table class="form-table">
				<tr valign="top"><th scope="row"><label for="qq_number">QQ号码</label></th>
					<td><input type="text" name="qq_number" id="qq_number" value="<?php echo $qq_number; ?>" class="regular-text" /></td>
				</tr>
				<tr valign="top"><th scope="row"><label for="qq_password">QQ密码</label></th>
					<td><input type="text" name="qq_password" id="qq_password" value="<?php echo $qq_password; ?>" class="regular-text" /></td>
				</tr>
				<tr valign="top"><th scope="row">同步全文？</th>
					<td>
					<label for="qzone_full_text">
					<input name="qzone_full_text" type="checkbox" <?php if($qzone_full_text) echo "checked"; ?> id="qzone_full_text" value="1">
					是否同步全文？</label>
					</td>
				</table>
			<p class="submit">
			<input type="submit" name="submit" class="button-primary" value="<?php _e('Save Changes') ?>" />
			</p>

		</form>
	</div>
	<?php	
}

